Educational Codeforces Round 87 (Rated for Div. 2) 补题 A~D include B.Ternary String、D.Multiset

快两个月前的一场才发现当时电脑重装用的clang代码惨目忍睹233

A. Alarm Clock
https://codeforces.com/contest/1354/problem/A
题意:模拟题。要睡a分钟,b分钟后闹钟响,如果响的时候没睡够a分钟,设c分钟后响,并花d分钟重新入睡,如果响的时候还没睡着,设c分钟后响,并花d分钟重新入睡,如果响的时候睡够了a分钟 起床,判断能否起床,如果能,什么时候起床。

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <queue>
#include <climits>
#include <cmath>
using namespace std;
typedef long long ll;
int n;
int main() {
    
    
    ios::sync_with_stdio(0);
    ll a, b, c, d;
    int t; cin >> t;
    while(t--) {
    
    
        cin >> a >> b >> c >> d;
        if(b >= a) {
    
    
            cout << b << endl;
            continue;
        }
 
        ll x = a - b;
 
        ll res = b;
 
        if(c - d <= 0) {
    
    
            if(x == 0) {
    
    
                cout << b << endl;
                continue;
            }
            else {
    
    
                cout << -1 << endl;
                continue;
            }
        }
 
        res += ceil((double)x / (c - d)) * c;
 
        cout << res << endl;
    }
    return 0;
}
 

B. Ternary String
https://codeforces.com/contest/1354/problem/B
题意:求包含123的最短串
思路:分别记123出现次数的前缀和,二分查找。check函数见代码。

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <queue>
#include <climits>
#include <cmath>
#include <cstring>
using namespace std;
typedef long long ll;
const int maxn = 5e5 + 100;
const ll mod = 1e9 + 7;
int n;
const double pi = 4 * atan(1.0);
 
char str[maxn];
int dp[4][maxn];
set<char> s;
int len;
int check(int x) {
    
    
    for(int i = 1;  i <= len - x; i++) {
    
    
        bool flag = 1;
        for(int j = 1; j <= 3; j++) {
    
    
            if(dp[j][i + x] - dp[j][i - 1] < 1) {
    
    
                flag = 0;
                break;
            }
        }
        if(flag == 1) return true;
    }
 
    return false;
}
 
int main() {
    
    
   // ios::sync_with_stdio(0);
    int t; scanf("%d", &t);
    while(t--) {
    
    
        s.clear();
        scanf("%s", str + 1);
 
        len = strlen(str + 1);
 
        for(int i = 1; i <= len; i++) {
    
    
            for(int j = 1; j <= 3; j++) dp[j][i] = dp[j][i-1];
            dp[str[i]-'0'][i] = dp[str[i] - '0'][i-1] + 1;
            s.insert(str[i]);
        }
 
        if(s.size() < 3) {
    
    
            cout << 0 << endl;
            continue;
        }
 
        int l = 1, r = len;
 
        int ans = 0;
        while(l <= r) {
    
    
          //  cout << "test" << endl;
            int mid = (l + r) >> 1;
            if(check(mid)) {
    
    
                ans = mid;
                r = mid - 1;
            }
            else l = mid + 1;
        }
 
        printf("%d\n", ans + 1);
 
    }
    return 0;
}

C1. Simple Polygon Embedding
https://codeforces.com/contest/1354/problem/C1

题意:找到能包含2n边形的最小正方形。
思路:计算几何,通过平面几何推导,见下图。
在这里插入图片描述

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <queue>
#include <climits>
#include <cmath>
using namespace std;
typedef long long ll;
 
int n;
const double pi = 4 * atan(1.0);
int main() {
    
    
    //ios::sync_with_stdio(0);
    ll a, b, c, d;
    int t; cin >> t;
    while(t--) {
    
    
        int n;
        scanf("%d", &n);
 
        printf("%.7f\n", tan(1.0 * (1 * n - 1) * pi / n / 2.0));
 
    }
    
    return 0;
}

D. Multiset
https://codeforces.com/contest/1354/problem/D
本场最有意思的一个题。
题意:给一个数组a,和q次操作p[i],p[i]>0时表示将p[i]插入到集合a中,p[i]<0时表示删除abs(p[i])位置的数,然后输出任意一个数组中的数。
思路:Note that the memory limit is unusual. 28mb的内存把线段树和树状数组卡到MLE的边缘。场上树状数组+二分勉强过了,但是FST了。至于为什么FST,debug了好久都没找到。
找到了一个很惊艳的解法。二分0~max,统计mid的位置。

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn = 2e6 + 100;
const int mod = 1e9 + 7;

int n, q;
int a[maxn], p[maxn];
int check(int x) {
    
    
    int cnt = 0;
    for (int i = 1; i <= n; i++) if (a[i] <= x) cnt++;

    for (int i = 1; i <= q; i++) {
    
    
        if (p[i] < 0 && -p[i] <= cnt) cnt--;
        else if (p[i] > 0 && p[i] <= x) cnt++;
    }

    return cnt;
}

int main() {
    
    
    scanf("%d%d", &n, &q);
    for (int i = 1; i <= n; i++) scanf("%d", &a[i]);
    for (int i = 1; i <= q; i++) scanf("%d", &p[i]);

    int l = 1, r = 2e6;

    while (l <= r) {
    
    
        int mid = l + r >> 1;
        if (check(mid) > 0) r = mid - 1;
        else l = mid + 1;
    }
    
    if (l > 2e6) l = 0;

    printf("%d\n", l);

    return 0;
}

猜你喜欢

转载自blog.csdn.net/weixin_43269437/article/details/107238209